Index: src/UIElements/CommandLineUI/Query/FileCommandLineQuery.cpp
===================================================================
--- src/UIElements/CommandLineUI/Query/FileCommandLineQuery.cpp	(revision 573ca5fad13d63566ba36dd8f4507d519d51fa15)
+++ src/UIElements/CommandLineUI/Query/FileCommandLineQuery.cpp	(revision 573ca5fad13d63566ba36dd8f4507d519d51fa15)
@@ -0,0 +1,43 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * FileCommandLineQuery.cpp
+ *
+ *  Created on: Oct 25, 2010
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Helpers/MemDebug.hpp"
+
+#include "CommandLineUI/CommandLineDialog.hpp"
+
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
+#include "CommandLineParser.hpp"
+
+CommandLineDialog::FileCommandLineQuery::FileCommandLineQuery(string title, string _description) :
+    Dialog::FileQuery(title, _description)
+{}
+
+CommandLineDialog::FileCommandLineQuery::~FileCommandLineQuery() {}
+
+bool CommandLineDialog::FileCommandLineQuery::handle() {
+  if (CommandLineParser::getInstance().vm.count(getTitle())) {
+    tmp = CommandLineParser::getInstance().vm[getTitle()].as< boost::filesystem::path >();
+    return true;
+  } else {
+    DoeLog(1) && (eLog() << Verbose(1) << "CommandLineUI parsing error: Missing string for " << getTitle() << "." << endl);
+    return false;
+  }
+}
+
Index: src/UIElements/CommandLineUI/Query/IntCommandLineQuery.cpp
===================================================================
--- src/UIElements/CommandLineUI/Query/IntCommandLineQuery.cpp	(revision 573ca5fad13d63566ba36dd8f4507d519d51fa15)
+++ src/UIElements/CommandLineUI/Query/IntCommandLineQuery.cpp	(revision 573ca5fad13d63566ba36dd8f4507d519d51fa15)
@@ -0,0 +1,43 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * IntCommandLineQuery.cpp
+ *
+ *  Created on: Oct 25, 2010
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Helpers/MemDebug.hpp"
+
+#include "CommandLineUI/CommandLineDialog.hpp"
+
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
+#include "CommandLineParser.hpp"
+
+CommandLineDialog::IntCommandLineQuery::IntCommandLineQuery(string title, string _description) :
+    Dialog::IntQuery(title, _description)
+{}
+
+CommandLineDialog::IntCommandLineQuery::~IntCommandLineQuery() {}
+
+bool CommandLineDialog::IntCommandLineQuery::handle() {
+  if (CommandLineParser::getInstance().vm.count(getTitle())) {
+    tmp = CommandLineParser::getInstance().vm[getTitle()].as<int>();
+    return true;
+  } else {
+    DoeLog(1) && (eLog() << Verbose(1) << "CommandLineUI parsing error: Missing integer for " << getTitle() << "." << endl);
+    return false;
+  }
+}
+
Index: src/UIElements/CommandLineUI/Query/IntsCommandLineQuery.cpp
===================================================================
--- src/UIElements/CommandLineUI/Query/IntsCommandLineQuery.cpp	(revision 573ca5fad13d63566ba36dd8f4507d519d51fa15)
+++ src/UIElements/CommandLineUI/Query/IntsCommandLineQuery.cpp	(revision 573ca5fad13d63566ba36dd8f4507d519d51fa15)
@@ -0,0 +1,43 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * IntsCommandLineQuery.cpp
+ *
+ *  Created on: Oct 25, 2010
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Helpers/MemDebug.hpp"
+
+#include "CommandLineUI/CommandLineDialog.hpp"
+
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
+#include "CommandLineParser.hpp"
+
+CommandLineDialog::IntsCommandLineQuery::IntsCommandLineQuery(string title, string _description) :
+    Dialog::IntsQuery(title, _description)
+{}
+
+CommandLineDialog::IntsCommandLineQuery::~IntsCommandLineQuery() {}
+
+bool CommandLineDialog::IntsCommandLineQuery::handle() {
+  if (CommandLineParser::getInstance().vm.count(getTitle())) {
+    tmp = CommandLineParser::getInstance().vm[getTitle()].as< std::vector<int> >();
+    return true;
+  } else {
+    DoeLog(1) && (eLog() << Verbose(1) << "CommandLineUI parsing error: Missing integers for " << getTitle() << "." << endl);
+    return false;
+  }
+}
+
Index: src/UIElements/CommandLineUI/Query/MoleculeCommandLineQuery.cpp
===================================================================
--- src/UIElements/CommandLineUI/Query/MoleculeCommandLineQuery.cpp	(revision 573ca5fad13d63566ba36dd8f4507d519d51fa15)
+++ src/UIElements/CommandLineUI/Query/MoleculeCommandLineQuery.cpp	(revision 573ca5fad13d63566ba36dd8f4507d519d51fa15)
@@ -0,0 +1,47 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * MoleculeCommandLineQuery.cpp
+ *
+ *  Created on: Oct 25, 2010
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Helpers/MemDebug.hpp"
+
+#include <Descriptors/MoleculeDescriptor.hpp>
+#include <Descriptors/MoleculeIdDescriptor.hpp>
+#include "CommandLineUI/CommandLineDialog.hpp"
+
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
+#include "CommandLineParser.hpp"
+
+CommandLineDialog::MoleculeCommandLineQuery::MoleculeCommandLineQuery(string title, string _description) :
+    Dialog::MoleculeQuery(title, _description)
+{}
+
+CommandLineDialog::MoleculeCommandLineQuery::~MoleculeCommandLineQuery() {}
+
+bool CommandLineDialog::MoleculeCommandLineQuery::handle() {
+  int IdxOfMol = -1;
+  if (CommandLineParser::getInstance().vm.count(getTitle())) {
+    IdxOfMol = CommandLineParser::getInstance().vm[getTitle()].as<int>();
+    tmp = World::getInstance().getMolecule(MoleculeById(IdxOfMol));
+    return true;
+  } else {
+    DoeLog(1) && (eLog() << Verbose(1) << "CommandLineUI parsing error: Missing molecule for " << getTitle() << "." << endl);
+    return false;
+  }
+}
+
Index: src/UIElements/CommandLineUI/Query/MoleculesCommandLineQuery.cpp
===================================================================
--- src/UIElements/CommandLineUI/Query/MoleculesCommandLineQuery.cpp	(revision 573ca5fad13d63566ba36dd8f4507d519d51fa15)
+++ src/UIElements/CommandLineUI/Query/MoleculesCommandLineQuery.cpp	(revision 573ca5fad13d63566ba36dd8f4507d519d51fa15)
@@ -0,0 +1,52 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * MoleculesCommandLineQuery.cpp
+ *
+ *  Created on: Oct 25, 2010
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Helpers/MemDebug.hpp"
+
+#include <Descriptors/MoleculeDescriptor.hpp>
+#include <Descriptors/MoleculeIdDescriptor.hpp>
+#include "CommandLineUI/CommandLineDialog.hpp"
+
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
+#include "CommandLineParser.hpp"
+#include "World.hpp"
+
+CommandLineDialog::MoleculesCommandLineQuery::MoleculesCommandLineQuery(string title, string _description) :
+    Dialog::MoleculesQuery(title, _description)
+{}
+
+CommandLineDialog::MoleculesCommandLineQuery::~MoleculesCommandLineQuery() {}
+
+bool CommandLineDialog::MoleculesCommandLineQuery::handle() {
+  std::vector<int> IdxOfMol;
+  if (CommandLineParser::getInstance().vm.count(getTitle())) {
+    IdxOfMol = CommandLineParser::getInstance().vm[getTitle()].as< std::vector<int> >();
+    for (std::vector<int>::iterator iter = IdxOfMol.begin(); iter != IdxOfMol.end(); ++iter) {
+      temp = World::getInstance().getMolecule(MoleculeById(*iter));
+      if (temp)
+        tmp.push_back(temp);
+    }
+    return true;
+  } else {
+    DoeLog(1) && (eLog() << Verbose(1) << "CommandLineUI parsing error: Missing molecules for " << getTitle() << "." << endl);
+    return false;
+  }
+}
+
Index: src/UIElements/CommandLineUI/Query/StringCommandLineQuery.cpp
===================================================================
--- src/UIElements/CommandLineUI/Query/StringCommandLineQuery.cpp	(revision 573ca5fad13d63566ba36dd8f4507d519d51fa15)
+++ src/UIElements/CommandLineUI/Query/StringCommandLineQuery.cpp	(revision 573ca5fad13d63566ba36dd8f4507d519d51fa15)
@@ -0,0 +1,43 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * StringCommandLineQuery.cpp
+ *
+ *  Created on: Oct 25, 2010
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Helpers/MemDebug.hpp"
+
+#include "CommandLineUI/CommandLineDialog.hpp"
+
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
+#include "CommandLineParser.hpp"
+
+CommandLineDialog::StringCommandLineQuery::StringCommandLineQuery(string title, string _description) :
+    Dialog::StringQuery(title, _description)
+{}
+
+CommandLineDialog::StringCommandLineQuery::~StringCommandLineQuery() {}
+
+bool CommandLineDialog::StringCommandLineQuery::handle() {
+  if (CommandLineParser::getInstance().vm.count(getTitle())) {
+    tmp = CommandLineParser::getInstance().vm[getTitle()].as<string>();
+    return true;
+  } else {
+    DoeLog(1) && (eLog() << Verbose(1) << "CommandLineUI parsing error: Missing string for " << getTitle() << "." << endl);
+    return false;
+  }
+}
+
Index: src/UIElements/CommandLineUI/Query/StringsCommandLineQuery.cpp
===================================================================
--- src/UIElements/CommandLineUI/Query/StringsCommandLineQuery.cpp	(revision 573ca5fad13d63566ba36dd8f4507d519d51fa15)
+++ src/UIElements/CommandLineUI/Query/StringsCommandLineQuery.cpp	(revision 573ca5fad13d63566ba36dd8f4507d519d51fa15)
@@ -0,0 +1,43 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * StringsCommandLineQuery.cpp
+ *
+ *  Created on: Oct 25, 2010
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Helpers/MemDebug.hpp"
+
+#include "CommandLineUI/CommandLineDialog.hpp"
+
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
+#include "CommandLineParser.hpp"
+
+CommandLineDialog::StringsCommandLineQuery::StringsCommandLineQuery(string title, string _description) :
+    Dialog::StringsQuery(title, _description)
+{}
+
+CommandLineDialog::StringsCommandLineQuery::~StringsCommandLineQuery() {}
+
+bool CommandLineDialog::StringsCommandLineQuery::handle() {
+  if (CommandLineParser::getInstance().vm.count(getTitle())) {
+    tmp = CommandLineParser::getInstance().vm[getTitle()].as< vector<string> >();
+    return true;
+  } else {
+    DoeLog(1) && (eLog() << Verbose(1) << "CommandLineUI parsing error: Missing strings for " << getTitle() << "." << endl);
+    return false;
+  }
+}
+
Index: src/UIElements/CommandLineUI/Query/VectorCommandLineQuery.cpp
===================================================================
--- src/UIElements/CommandLineUI/Query/VectorCommandLineQuery.cpp	(revision 573ca5fad13d63566ba36dd8f4507d519d51fa15)
+++ src/UIElements/CommandLineUI/Query/VectorCommandLineQuery.cpp	(revision 573ca5fad13d63566ba36dd8f4507d519d51fa15)
@@ -0,0 +1,56 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * VectorCommandLineQuery.cpp
+ *
+ *  Created on: Oct 25, 2010
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Helpers/MemDebug.hpp"
+
+#include "CommandLineUI/CommandLineDialog.hpp"
+
+#include "Actions/Values.hpp"
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
+#include "CommandLineParser.hpp"
+#include "LinearAlgebra/Vector.hpp"
+#include "Box.hpp"
+#include "World.hpp"
+
+CommandLineDialog::VectorCommandLineQuery::VectorCommandLineQuery(string title, bool _check, string _description) :
+    Dialog::VectorQuery(title,_check, _description)
+{}
+
+CommandLineDialog::VectorCommandLineQuery::~VectorCommandLineQuery()
+{}
+
+bool CommandLineDialog::VectorCommandLineQuery::handle() {
+  VectorValue temp;
+  if (CommandLineParser::getInstance().vm.count(getTitle())) {
+    temp = CommandLineParser::getInstance().vm[getTitle()].as< VectorValue >();
+    tmp[0] = temp.x;
+    tmp[1] = temp.y;
+    tmp[2] = temp.z;
+    if ((check) && (!World::getInstance().getDomain().isInside(tmp))) {
+      DoeLog(1) && (eLog() << Verbose(1) << "Vector " << tmp << " would be outside of box domain." << endl);
+      return false;
+    }
+    return true;
+  } else {
+    DoeLog(1) && (eLog() << Verbose(1) << "CommandLineUI parsing error: Missing vector for " << getTitle() << "." << endl);
+    return false;
+  }
+}
+
Index: src/UIElements/CommandLineUI/Query/VectorsCommandLineQuery.cpp
===================================================================
--- src/UIElements/CommandLineUI/Query/VectorsCommandLineQuery.cpp	(revision 573ca5fad13d63566ba36dd8f4507d519d51fa15)
+++ src/UIElements/CommandLineUI/Query/VectorsCommandLineQuery.cpp	(revision 573ca5fad13d63566ba36dd8f4507d519d51fa15)
@@ -0,0 +1,58 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * VectorsCommandLineQuery.cpp
+ *
+ *  Created on: Oct 25, 2010
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Helpers/MemDebug.hpp"
+
+#include <vector>
+
+#include "CommandLineUI/CommandLineDialog.hpp"
+
+#include "Actions/Values.hpp"
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
+#include "CommandLineParser.hpp"
+#include "World.hpp"
+
+CommandLineDialog::VectorsCommandLineQuery::VectorsCommandLineQuery(string title, bool _check, string _description) :
+    Dialog::VectorsQuery(title,_check, _description)
+{}
+
+CommandLineDialog::VectorsCommandLineQuery::~VectorsCommandLineQuery()
+{}
+
+bool CommandLineDialog::VectorsCommandLineQuery::handle() {
+  std::vector<VectorValue> temporary;
+  if (CommandLineParser::getInstance().vm.count(getTitle())) {
+    temporary = CommandLineParser::getInstance().vm[getTitle()].as< std::vector<VectorValue> >();
+    for(std::vector<VectorValue>::iterator iter = temporary.begin(); iter != temporary.end(); ++iter) {
+      temp[0] = (*iter).x;
+      temp[1] = (*iter).y;
+      temp[2] = (*iter).z;
+      if ((!check) || (World::getInstance().getDomain().isInside(temp)))
+        tmp.push_back(temp);
+      else
+        DoeLog(1) && (eLog() << Verbose(1) << "Vector " << temp << " would be outside of box domain." << endl);
+    }
+    return true;
+  } else {
+    DoeLog(1) && (eLog() << Verbose(1) << "CommandLineUI parsing error: Missing vectors for " << getTitle() << "." << endl);
+    return false;
+  }
+}
+
Index: src/UIElements/Dialog.cpp
===================================================================
--- src/UIElements/Dialog.cpp	(revision 6940bb556236165ebf89b8495b117042efebb708)
+++ src/UIElements/Dialog.cpp	(revision 573ca5fad13d63566ba36dd8f4507d519d51fa15)
@@ -23,12 +23,13 @@
 #include "Actions/ValueStorage.hpp"
 
+#include "Helpers/Log.hpp"
 #include "Helpers/Verbose.hpp"
-#include "atom.hpp"
-#include "Box.hpp"
-#include "element.hpp"
-#include "molecule.hpp"
-#include "LinearAlgebra/BoxVector.hpp"
-#include "LinearAlgebra/Vector.hpp"
-#include "LinearAlgebra/Matrix.hpp"
+
+class Atom;
+class Box;
+class element;
+class Matrix;
+class molecule;
+class Vector;
 
 using namespace std;
@@ -180,229 +181,10 @@
 }
 
-/****************** Query types Infrastructure **************************/
-
-// Base class
-Dialog::Query::Query(string _title, string _description) :
-    title(_title),
-    description(_description)
-{}
-
-Dialog::Query::~Query() {}
-
-const std::string Dialog::Query::getTitle() const{
-  return title;
+template <> void Dialog::query< boost::filesystem::path >(const char *token, std::string description)
+{
+  queryFile(token, description);
 }
 
-const std::string Dialog::Query::getDescription() const{
-  return description;
-}
-// empty Queries
-
-Dialog::EmptyQuery::EmptyQuery(string title, std::string description) :
-    Query(title, description)
-{}
-
-Dialog::EmptyQuery::~EmptyQuery() {}
-
-void Dialog::EmptyQuery::setResult() {
-}
-
-// Int Queries
-
-Dialog::IntQuery::IntQuery(string title, std::string description) :
-    Query(title, description)
-{}
-
-Dialog::IntQuery::~IntQuery() {}
-
-void Dialog::IntQuery::setResult() {
-  ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
-}
-
-// Ints Queries
-
-Dialog::IntsQuery::IntsQuery(string title, std::string description) :
-    Query(title, description)
-{}
-
-Dialog::IntsQuery::~IntsQuery() {}
-
-void Dialog::IntsQuery::setResult() {
-  ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
-}
-
-// Bool Queries
-
-Dialog::BooleanQuery::BooleanQuery(string title,std::string description) :
-    Query(title, description)
-{}
-
-Dialog::BooleanQuery::~BooleanQuery() {}
-
-void Dialog::BooleanQuery::setResult() {
-  ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
-}
-
-// String Queries
-
-Dialog::StringQuery::StringQuery(string title,std::string _description) :
-    Query(title, _description)
-{}
-
-Dialog::StringQuery::~StringQuery() {};
-
-void Dialog::StringQuery::setResult() {
-  ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
-}
-
-// Strings Queries
-
-Dialog::StringsQuery::StringsQuery(string title,std::string _description) :
-    Query(title, _description)
-{}
-
-Dialog::StringsQuery::~StringsQuery() {};
-
-void Dialog::StringsQuery::setResult() {
-  ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
-}
-
-// Double Queries
-
-Dialog::DoubleQuery::DoubleQuery(string title, std::string _description) :
-    Query(title, _description)
-{}
-
-Dialog::DoubleQuery::~DoubleQuery() {};
-
-void Dialog::DoubleQuery::setResult() {
-  ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
-}
-
-// Doubles Queries
-
-Dialog::DoublesQuery::DoublesQuery(string title, std::string _description) :
-    Query(title, _description)
-{}
-
-Dialog::DoublesQuery::~DoublesQuery() {};
-
-void Dialog::DoublesQuery::setResult() {
-  ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
-}
-
-
-// Atom Queries
-
-Dialog::AtomQuery::AtomQuery(string title, std::string _description) :
-    Query(title, _description),
-    tmp(0)
-{}
-
-Dialog::AtomQuery::~AtomQuery() {}
-
-void Dialog::AtomQuery::setResult() {
-  ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
-}
-
-// Atoms Queries
-
-Dialog::AtomsQuery::AtomsQuery(string title, std::string _description) :
-    Query(title, _description),
-    tmp(0)
-{}
-
-Dialog::AtomsQuery::~AtomsQuery() {}
-
-void Dialog::AtomsQuery::setResult() {
-  ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
-}
-
-// Molecule Queries
-
-Dialog::MoleculeQuery::MoleculeQuery(string title, std::string _description) :
-    Query(title, _description),
-    tmp(0)
-{}
-
-Dialog::MoleculeQuery::~MoleculeQuery() {}
-
-void Dialog::MoleculeQuery::setResult() {
-  ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
-}
-
-// Molecules Queries
-
-Dialog::MoleculesQuery::MoleculesQuery(string title, std::string _description) :
-    Query(title, _description),
-    tmp(0)
-{}
-
-Dialog::MoleculesQuery::~MoleculesQuery() {}
-
-void Dialog::MoleculesQuery::setResult() {
-  ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
-}
-
-// Vector Queries
-
-Dialog::VectorQuery::VectorQuery(std::string title,bool _check, std::string _description) :
-  Query(title, _description),
-  check(_check)
-{}
-
-Dialog::VectorQuery::~VectorQuery()
-{}
-
-void Dialog::VectorQuery::setResult() {
-  ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
-}
-
-// Vectors Queries
-
-Dialog::VectorsQuery::VectorsQuery(std::string title,bool _check, std::string _description) :
-  Query(title, _description),
-  check(_check)
-{}
-
-Dialog::VectorsQuery::~VectorsQuery()
-{}
-
-void Dialog::VectorsQuery::setResult() {
-  ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
-}
-
-// Box Queries
-
-Dialog::BoxQuery::BoxQuery(std::string title, std::string _description) :
-  Query(title, _description)
-{}
-
-Dialog::BoxQuery::~BoxQuery()
-{}
-
-void Dialog::BoxQuery::setResult() {
-  ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
-}
-
-// Element Queries
-Dialog::ElementQuery::ElementQuery(std::string title, std::string _description) :
-  Query(title, _description)
-  {}
-
-Dialog::ElementQuery::~ElementQuery(){}
-
-void Dialog::ElementQuery::setResult(){
-  ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
-}
-
-// Elements Queries
-Dialog::ElementsQuery::ElementsQuery(std::string title, std::string _description) :
-  Query(title, _description)
-  {}
-
-Dialog::ElementsQuery::~ElementsQuery(){}
-
-void Dialog::ElementsQuery::setResult(){
-  ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
-}
+/************************** Query Infrastructure ************************/
+/*       ---> shifted to folder Query                                   */
+/************************************************************************/
Index: src/UIElements/Dialog.hpp
===================================================================
--- src/UIElements/Dialog.hpp	(revision 6940bb556236165ebf89b8495b117042efebb708)
+++ src/UIElements/Dialog.hpp	(revision 573ca5fad13d63566ba36dd8f4507d519d51fa15)
@@ -13,4 +13,6 @@
 #include<vector>
 
+#include <boost/filesystem.hpp>
+
 #include "Box.hpp"
 #include "LinearAlgebra/Vector.hpp"
@@ -24,11 +26,11 @@
 /** Dialog is one of the two main classes of the UIFactory base class.
  *
- * The Dialog is meant for asking the user for information needed to perform actions he
- * desires, such as asking for a position in space or a length.
+ * The Dialog is meant for asking the user for information needed to perform
+ * actions he desires, such as asking for a position in space or a length.
  *
- * For this purpose there is the base class Query and numerous specializations for each
- * of the types to be asked. There are primitives integer, doubles and string, but also
- * advanced types such as element, molecule or Vector. There is also an empty query for
- * displaying text.
+ * For this purpose there is the base class Query and numerous specializations
+ * for each of the types to be asked. There are primitives integer, doubles and
+ * string, but also advanced types such as element, molecule or Vector. There
+ * is also an empty query for displaying text.
  */
 class Dialog
@@ -57,4 +59,5 @@
   virtual void queryElement(const char*, std::string = "")=0;
   virtual void queryElements(const char*, std::string = "")=0;
+  virtual void queryFile(const char*, std::string = "")=0;
 
   virtual bool display();
@@ -76,5 +79,30 @@
   //due to lack of common code for query types as well as GUI-Types (all subtypes differ a lot)
 
-  //base class for all queries
+  /** Base class for all queries.
+   *
+   *
+   * <h1>How to add another query?</h1>
+   *
+   * Let's say  we want to query for a type called \a Value.
+   *
+   * Then, we do the following:
+   *  -# Add a class ValueQuery inside class Dialog, the class contains
+   *    -# constructor/destructor (latter virtual! because of derived class)
+   *    -# virtual bool handle() and virtual void setResult()
+   *    -# a protected member tmp of type Value (NOTE: herein the result is stored)
+   *    -# if temporaries for conversion are needed put them in here
+   *  -# add a function queryValue
+   *  -# now, for each of the GUIs we basically have to repeat the above, i.e.
+   *     add the class and the function that implement the virtual ones above.
+   *    -# QT: an extra class called ValueQtQueryPipe that actually handles
+   *       showing dialogs to obtain the value and placing it into the \a tmp
+   *       variable (via a given pointer to it as reference). handle() will
+   *       simply return true. This is needed because of a restriction of Qt4:
+   *       its meta-object-compiler does not like nested classes.
+   *    -# CommandLine: nothing special, handle() imports value from \a
+   *       CommandLineParser and sets the tmp variable.
+   *    -# Text: nothing special, handle() queries the user and sets the tmp
+   *       variable
+   */
   class Query {
     friend class Dialog;
@@ -271,4 +299,14 @@
   };
 
+  class FileQuery : public Query {
+  public:
+    FileQuery(std::string title, std::string _description = "");
+    virtual ~FileQuery();
+    virtual bool handle()=0;
+    virtual void setResult();
+  protected:
+    boost::filesystem::path tmp;
+  };
+
 void registerQuery(Query* query);
 
Index: src/UIElements/Makefile.am
===================================================================
--- src/UIElements/Makefile.am	(revision 6940bb556236165ebf89b8495b117042efebb708)
+++ src/UIElements/Makefile.am	(revision 573ca5fad13d63566ba36dd8f4507d519d51fa15)
@@ -41,4 +41,23 @@
   ${TEXTUISOURCE} \
   ${VIEWSOURCE} \
+  Query/AtomQuery.cpp \
+  Query/AtomsQuery.cpp \
+  Query/BooleanQuery.cpp \
+  Query/BoxQuery.cpp \
+  Query/DoubleQuery.cpp \
+  Query/DoublesQuery.cpp \
+  Query/ElementQuery.cpp \
+  Query/ElementsQuery.cpp \
+  Query/EmptyQuery.cpp \
+  Query/FileQuery.cpp \
+  Query/IntQuery.cpp \
+  Query/IntsQuery.cpp \
+  Query/MoleculeQuery.cpp \
+  Query/MoleculesQuery.cpp \
+  Query/Query.cpp \
+  Query/StringQuery.cpp \
+  Query/StringsQuery.cpp \
+  Query/VectorQuery.cpp \
+  Query/VectorsQuery.cpp \
   Dialog.cpp \
   MainWindow.cpp
@@ -54,4 +73,22 @@
 
 TEXTUISOURCE = \
+  TextUI/Query/AtomsTextQuery.cpp \
+  TextUI/Query/AtomTextQuery.cpp \
+  TextUI/Query/BooleanTextQuery.cpp \
+  TextUI/Query/BoxTextQuery.cpp \
+  TextUI/Query/DoubleTextQuery.cpp \
+  TextUI/Query/DoublesTextQuery.cpp \
+  TextUI/Query/ElementTextQuery.cpp \
+  TextUI/Query/ElementsTextQuery.cpp \
+  TextUI/Query/EmptyTextQuery.cpp \
+  TextUI/Query/FileTextQuery.cpp \
+  TextUI/Query/IntTextQuery.cpp \
+  TextUI/Query/IntsTextQuery.cpp \
+  TextUI/Query/MoleculesTextQuery.cpp \
+  TextUI/Query/MoleculeTextQuery.cpp \
+  TextUI/Query/StringTextQuery.cpp \
+  TextUI/Query/StringsTextQuery.cpp \
+  TextUI/Query/VectorTextQuery.cpp \
+  TextUI/Query/VectorsTextQuery.cpp \
   TextUI/TextDialog.cpp \
   TextUI/TextStatusIndicator.cpp \
@@ -65,4 +102,22 @@
 
 COMMANDLINEUISOURCE = \
+  CommandLineUI/Query/AtomCommandLineQuery.cpp \
+  CommandLineUI/Query/AtomsCommandLineQuery.cpp \
+  CommandLineUI/Query/BooleanCommandLineQuery.cpp \
+  CommandLineUI/Query/BoxCommandLineQuery.cpp \
+  CommandLineUI/Query/DoubleCommandLineQuery.cpp \
+  CommandLineUI/Query/DoublesCommandLineQuery.cpp \
+  CommandLineUI/Query/ElementCommandLineQuery.cpp \
+  CommandLineUI/Query/ElementsCommandLineQuery.cpp \
+  CommandLineUI/Query/EmptyCommandLineQuery.cpp \
+  CommandLineUI/Query/FileCommandLineQuery.cpp \
+  CommandLineUI/Query/IntCommandLineQuery.cpp \
+  CommandLineUI/Query/IntsCommandLineQuery.cpp \
+  CommandLineUI/Query/MoleculeCommandLineQuery.cpp \
+  CommandLineUI/Query/MoleculesCommandLineQuery.cpp \
+  CommandLineUI/Query/StringCommandLineQuery.cpp \
+  CommandLineUI/Query/StringsCommandLineQuery.cpp \
+  CommandLineUI/Query/VectorCommandLineQuery.cpp \
+  CommandLineUI/Query/VectorsCommandLineQuery.cpp \
   CommandLineUI/CommandLineDialog.cpp \
   CommandLineUI/CommandLineStatusIndicator.cpp \
Index: src/UIElements/Menu/Qt4/QtMenu.cpp
===================================================================
--- src/UIElements/Menu/Qt4/QtMenu.cpp	(revision 573ca5fad13d63566ba36dd8f4507d519d51fa15)
+++ src/UIElements/Menu/Qt4/QtMenu.cpp	(revision 573ca5fad13d63566ba36dd8f4507d519d51fa15)
@@ -0,0 +1,69 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * QtMenu.cpp
+ *
+ *  Created on: Jan 15, 2010
+ *      Author: crueger
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Menu/Qt4/QtMenu.hpp"
+
+#include <Qt/qaction.h>
+
+#include "Helpers/MemDebug.hpp"
+
+#include "Menu/MenuItem.hpp"
+
+QtMenu::QtMenu(const char * _title) :
+  QMenu(_title)
+{}
+
+QtMenu::~QtMenu()
+{
+  // yay... Just like Mario Bros.
+  for(list<QtMenuPipe*>::iterator it=plumbing.begin(); it != plumbing.end(); it++)
+    delete (*it);
+}
+
+void QtMenu::addItem(MenuItem* item) {
+  const string description = item->getDescription();
+  QAction *action = addAction(QString(description.c_str()));
+  QtMenuPipe *pipe = new QtMenuPipe(item,action);
+  QObject::connect(action, SIGNAL(triggered()),pipe,SLOT(called()));
+  plumbing.push_back(pipe);
+}
+
+void QtMenu::removeItem(MenuItem* item) {
+  list<QtMenuPipe*>::iterator iter;
+  for(iter=plumbing.begin(); iter!=plumbing.end(); iter++){
+    delete (*iter);
+  }
+}
+
+void QtMenu::display() {
+
+}
+
+QtMenuPipe::QtMenuPipe(MenuItem *_item, QAction *_action) :
+    theItem(_item), theAction(_action)
+{}
+
+QtMenuPipe::~QtMenuPipe() {
+  delete theAction;
+  delete theItem;
+}
+
+void QtMenuPipe::called() {
+  theItem->doTrigger();
+}
Index: src/UIElements/Menu/Qt4/QtMenu.hpp
===================================================================
--- src/UIElements/Menu/Qt4/QtMenu.hpp	(revision 573ca5fad13d63566ba36dd8f4507d519d51fa15)
+++ src/UIElements/Menu/Qt4/QtMenu.hpp	(revision 573ca5fad13d63566ba36dd8f4507d519d51fa15)
@@ -0,0 +1,50 @@
+/*
+ * QtMenu.hpp
+ *
+ *  Created on: Jan 15, 2010
+ *      Author: crueger
+ */
+
+#ifndef QTMENU_HPP_
+#define QTMENU_HPP_
+
+#include <list>
+
+#include <QtGui/QMenu>
+#include <QtCore/QObject>
+
+#include "Menu/Menu.hpp"
+
+class QtMenuPipe;
+
+class QtMenu : public QMenu, public Menu
+{
+  Q_OBJECT
+
+public:
+  QtMenu(const char *);
+  virtual ~QtMenu();
+
+  virtual void addItem(MenuItem*);
+  virtual void removeItem(MenuItem*);
+  virtual void display();
+private:
+  list<QtMenuPipe*> plumbing;
+};
+
+// This handles the plumbing from QT to internal Items
+// Slots from QT are redirected to internal methods.
+// This way methods can be used where no QT is available
+class QtMenuPipe : public QObject {
+  Q_OBJECT
+public:
+  QtMenuPipe(MenuItem*,QAction*);
+  virtual ~QtMenuPipe();
+public slots:
+  void called();
+private:
+  MenuItem *theItem;
+  QAction *theAction;
+};
+
+#endif /* QTMENU_HPP_ */
